ConcurrentBiMap (apache-cassandra API)
Date: 2018-02-14

org.apache.cassandra.utils

## Class ConcurrentBiMap<K,V>

- java.lang.Object
- - org.apache.cassandra.utils.ConcurrentBiMap<K,V>

- Type Parameters:
    `K` -
    `V` -
  All Implemented Interfaces:
    java.util.Map<K,V>

      public class ConcurrentBiMap<K,V>
      extends java.lang.Object
      implements java.util.Map<K,V>

  A variant of BiMap that permits concurrent access, and expects uniqueness of values in both domain and range. We synchronize on _modifications only_, and use ConcurrentHashMap so that readers can lookup safely. This does mean there could be races to lookup the inverse, but we aren't too worried about that.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K,V>`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Map<K,V>` | `forwardMap`
    `protected java.util.Map<V,K>` | `reverseMap`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `ConcurrentBiMap()`
    `protected` | `ConcurrentBiMap(java.util.Map<K,V> forwardMap, java.util.Map<V,K> reverseMap)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()`
    `boolean` | `containsKey(java.lang.Object key)`
    `boolean` | `containsValue(java.lang.Object value)`
    `java.util.Set<java.util.Map.Entry<K,V>>` | `entrySet()`
    `V` | `get(java.lang.Object key)`
    `java.util.Map<V,K>` | `inverse()`
    `boolean` | `isEmpty()`
    `java.util.Set<K>` | `keySet()`
    `V` | `put(K key, V value)`
    `void` | `putAll(java.util.Map<? extends K,? extends V> m)`
    `V` | `remove(java.lang.Object key)`
    `int` | `size()`
    `java.util.Collection<V>` | `values()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Field Detail

    - #### forwardMap

          protected final java.util.Map<K,V> forwardMap

    - #### reverseMap

          protected final java.util.Map<V,K> reverseMap

  - ### Constructor Detail

    - #### ConcurrentBiMap

          public ConcurrentBiMap()

    - #### ConcurrentBiMap

          protected ConcurrentBiMap(java.util.Map<K,V> forwardMap,
                                    java.util.Map<V,K> reverseMap)

  - ### Method Detail

    - #### inverse

          public java.util.Map<V,K> inverse()

    - #### clear

          public void clear()

      Specified by:
        `clear` in interface `java.util.Map<K,V>`

    - #### containsKey

          public boolean containsKey(java.lang.Object key)

      Specified by:
        `containsKey` in interface `java.util.Map<K,V>`

    - #### containsValue

          public boolean containsValue(java.lang.Object value)

      Specified by:
        `containsValue` in interface `java.util.Map<K,V>`

    - #### entrySet

          public java.util.Set<java.util.Map.Entry<K,V>> entrySet()

      Specified by:
        `entrySet` in interface `java.util.Map<K,V>`

    - #### get

          public V get(java.lang.Object key)

      Specified by:
        `get` in interface `java.util.Map<K,V>`

    - #### isEmpty

          public boolean isEmpty()

      Specified by:
        `isEmpty` in interface `java.util.Map<K,V>`

    - #### keySet

          public java.util.Set<K> keySet()

      Specified by:
        `keySet` in interface `java.util.Map<K,V>`

    - #### put

          public V put(K key,
                       V value)

      Specified by:
        `put` in interface `java.util.Map<K,V>`

    - #### putAll

          public void putAll(java.util.Map<? extends K,? extends V> m)

      Specified by:
        `putAll` in interface `java.util.Map<K,V>`

    - #### remove

          public V remove(java.lang.Object key)

      Specified by:
        `remove` in interface `java.util.Map<K,V>`

    - #### size

          public int size()

      Specified by:
        `size` in interface `java.util.Map<K,V>`

    - #### values

          public java.util.Collection<V> values()

      Specified by:
        `values` in interface `java.util.Map<K,V>`

Copyright © 2018 The Apache Software Foundation